View Issue Details

IDProjectCategoryLast Update
0025729AI War 2Crash/ExceptionNov 15, 2021 5:52 pm
ReporterDaniexpert Assigned Tox4000Bughunter  
Severityminor 
Status resolvedResolutionfixed 
Product VersionBeta 3.742 "Classic Map" For DLC1 
Fixed in VersionBeta 3.751 Faction Processing Groups 
Summary0025729: Jacobson DoCombatStepForPlanet error
Description10/30/2021 10:44:10 PM 3.741 SINGLEP DELAYED21: Jacobson DoCombatStepForPlanet error at debugStage 4300: System.IndexOutOfRangeException: Index was outside the bounds of the array.
  at Arcen.Universal.MersenneTwister.ReinitializeWithSeed (System.Int64 seed) [0x00033] in <6f30575e2f9f415da45b0053d91bb739>:0
  at Arcen.AIW2.External.EntitySimLogicImplementation_BaseInfo.DoCombatStepForPlanet (Arcen.AIW2.Core.Planet planet, Arcen.AIW2.Core.ArcenClientOrHostSimContextCore Context) [0x001d1] in <e767aecb2ac44ec297c2b00eeb864a6a>:0
TagsNo tags attached.

Relationships

related to 0025831 resolvedx4000Bughunter Game slows down and reports enormous numbers of errors 

Activities

x4000Bughunter

Nov 15, 2021 5:52 pm

administrator   ~0063311

Thanks!

* Added a new processing_group="Name" on faction definitions that is required.
** This allows us to aggregate "hey, am I allowed to run at the same time?" in the way we really need to. We had something like this before, but not enough.
** This in turn requires new xml in a new folder called SpecialFactionProcessingGroup, and that fills a SpecialFactionProcessingGroup object in the code, which is mostly used for LRP threading locks.

* UniqueNameForFactionToAvoidThreadConflicts has been removed, replaced with a reference to the faction's SpecialFactionProcessingGroup.

* Okay! This has been a problem for longer than I realized, as it turns out; it just has been more obvious in recent months.
** Essentially, the way we were handling factions that used shared resources for their "LRP processing" previously only attempted to not let them START in the same lrp sim cycle, but it was not preventing them from starting in multiple cycles and thus overlapping.
** Good grief, this was more untangling than expected. This SHOULD prove to be the end of any sort of "pathfinder already running" errors, but we'll have to wait longer and see if folks still run into it. I really don't think they will, knock on wood.
*** This should also solve any MersenneTwister.GenerateUInt issues, which are also basically an indication of a single randomizer being called by two threads at once.

Issue History

Date Modified Username Field Change
Oct 30, 2021 4:56 pm Daniexpert New Issue
Nov 15, 2021 3:26 pm BadgerBadger Relationship added related to 0025831
Nov 15, 2021 5:52 pm x4000Bughunter Assigned To => x4000Bughunter
Nov 15, 2021 5:52 pm x4000Bughunter Status new => resolved
Nov 15, 2021 5:52 pm x4000Bughunter Resolution open => fixed
Nov 15, 2021 5:52 pm x4000Bughunter Fixed in Version => Beta 3.751 Faction Processing Groups
Nov 15, 2021 5:52 pm x4000Bughunter Note Added: 0063311